/*******************************************/
/*******************************************/
/************* Master Mind *****************/
/*******************************************/
/*******************************************/
/*******************************************/

/******* Software Analtico-Deductivo ******/
/*********** por Javier Fueyo *************/
/** (todos los derechos reservados)  *******/
/*******************************************/

/********* versin para SWI-Prolog *********/
/*faltan:
        1.-las caracteristica in-out de las variables de cada
	predicado.
	2.-un comnetario explcito por  cada predicado.
	3.-un ejemplo por cada predicado.
	4.-mostrar en pantalla el clculo realizado por cada predicado.*/


:-dynamic( jugada/1).
:-dynamic( intento/3).

/*ruta de un nivel*/
/******************************************************************/
/******************************************************************/
/******************************************************************/
/******************************************************************/
/*1-master_mind*/

master_mind:-
	saludo, %1/1

	restablecer, %1/2

	combinacion(Solucion), %1/3

	once(seleccion(Solucion)), %1/4

	evaluar(Lugar, Solucion), %1/5

	Lugar = 4, %1/6

	write('  Solucin!!!!  '),

	!,

	despedida. %1/7













/*ruta de dos niveles*/
/******************************************************************/
/******************************************************************/
/******************************************************************/
/******************************************************************/


/******************************************************************/
/******************************************************************/
/*1/1-master_mind/saludo*/
saludo:-
	write('juego de ingenio'),
	nl,
	nl,
	write('master mind'),
	nl.

/******************************************************************/
/******************************************************************/
/*1/2-master_mind/restablecer*/
restablecer:-
	abolish(intento/3),
	abolish(jugada/1),
	asserta(jugada(0)).



/******************************************************************/
/******************************************************************/
/*1/3-master_mind/combinacion*/
combinacion( Solucion):-
		matriz( Matriz), %3/1
		!,
		!,
		sublista( Solucion_aux, 4, Matriz), %3/2
		permutacion( Solucion, Solucion_aux). %3/3
%		write('permutacion: '),
%		write( Solucion).



/******************************************************************/
/******************************************************************/
/*1/4-master_mind/seleccion*/
seleccion( Solucion):-
			jugada(N),
			ciclo_condiciones( Solucion, N).%1/4/1

/******************************************************************/
/******************************************************************/
/*1/5-master_mind/evaluar(Lugar, Solucion)*/
evaluar( Lugar, Solucion):-
%	nl,
	write( 'combinacin propuesta: '),
	write( Solucion),
	nl,
	write( 'Digito correcto y lugar correcto?:    '),
	read( Lugar),
%	nl,
	write( 'Dgito correcto y lugar incorrecto?:  '),
	read( Digito),
%	nl,
	jugada( N_aux),
	N is N_aux + 1,
	write( 'intento:  '),
	write( N),
	nl,
	write( '-----------------'),
	nl,
	assertz(intento( N, calificar( Lugar, Digito), Solucion) ),
	retract( jugada(N_aux)),
	asserta( jugada( N)).


/******************************************************************/
/******************************************************************/
/*1/6-master_mind/verificar*/


/******************************************************************/
/******************************************************************/
/*1/7-master_mind/despedida*/
despedida:-
	nl,
	nl,
	write('por javier fueyo'),
	nl,
	nl,
	nl,
	nl.







/*ruta de tres niveles*/
/******************************************************************/
/******************************************************************/
/******************************************************************/
/******************************************************************/

/******************************************************************/
/******************************************************************/
/*1/3/1-master_mind/combinacion/matriz*/
matriz( Matriz):-
%	nl,
%	write( 'matriz de digitos: '),
	digitos_matriz(Digitos_matriz), %1/3/1/1
%	write( Digitos_matriz),
%	nl,

%	write( 'calculando numero aleatorio: '),
	seleccionar_matriz_azar( Momento), %1/3/1/2
%	write( Momento),
%	nl,

%	write( 'calculando matriz adivinatoria: '),
	generar_permutacion( Momento, Digitos_matriz, Matriz), %1/3/1/3
%	write( Matriz),
%	nl,
	!.



/******************************************************************/
/******************************************************************/
/*1/3/2-master_mind/combinacion/sublista*/

/* Entrega todas las sublistas de cardinal N fijo,
teniendo en cuenta el orden, de una lista original. */

sublista( Sublista, N, Lista):-
%    write('predicado: sublista/3'),
%    write('sublista('),
%    write( Sublista),
%    write( ', '),
%    write( N),
%    write( ', '),
%    write( Lista),
%    write( ')'),
%    nl,


    longitud( M, Lista), %1/3/2/1
%    write('longitud lista matriz: '),
%    write( M),

%    nl,
%    write('listas binarias:'),
    binaria( Lista_binaria, M), %1/3/2/2
%    nl,
%    write( Lista_binaria),

    escoger_binaria( Lista_binaria, N), %1/3/2/3
    nl,
%    write('lista binaria escogida:'),
%    write( Lista_binaria),

    generar_cifra( Cifra, Lista_binaria, Lista), %1/3/2/4
%    nl,
%    write( 'cifra: '),
%    write( Cifra),

    sin_fantasma( Sublista, Cifra). %1/3/2/5
%    nl.
%    write('sublista:'),
%    write( Sublista).

/******************************************************************/
/******************************************************************/
/*1/3/3-master_mind/combinacion/permutacion*/
/**** genera las N! permutaciones de una lista de N elementos */
permutacion( [], []).
permutacion( [ Cabeza| Cola_permutada], Original):-
	eliminar( Cola_permuta, Cabeza, Original), %1/3/3/1
	permutacion( Cola_permutada, Cola_permuta).




/******************************************************************/
/******************************************************************/
/*1/4/1-master_mind/seleccion/ciclo_condiciones*/
ciclo_condiciones( _, 0):-!.
ciclo_condiciones( Solucion, N):-
	N_aux is N - 1,
	ciclo_condiciones( Solucion, N_aux),
	posibilidad( Posibilidad, N), %1/4/1/1
	Solucion = Posibilidad.






/*ruta de cuatro niveles*/
/******************************************************************/
/******************************************************************/
/******************************************************************/
/******************************************************************/


/******************************************************************/
/******************************************************************/
/*1/3/1/1-master_mind/combinacion/matriz/digitos_matriz*/
digitos_matriz( [ 0, 1, 2, 3, 4, 5]).


/******************************************************************/
/******************************************************************/
/*1/3/1/2-master_mind/combinacion/matriz/seleccionar_matriz_azar*/
seleccionar_matriz_azar( N):-
	factorial( 6, Factorial), %1/3/1/2/1
	N is random( Factorial) + 1.

/******************************************************************/
/******************************************************************/
/*1/3/1/3-master_mind/combinacion/matriz/generar_permutacion */
/*genera la eNsima permutacin segn una matriz */
generar_permutacion( Momento, Matriz, Matriz_permutada):-
	longitud( N, Matriz),
	lista_fantasma( Matriz_permutada, N), %1/3/1/3/1
	instanciar_matriz( Momento, Matriz, 6, Matriz_permutada). %1/3/1/3/2



/******************************************************************/
/******************************************************************/
/*1/3/2/1-master_mind/combinacion/sublista/longitud*/
/*** Longitud de una lista ***/

longitud( 0, []):- !.
longitud( N, [ _| Cola]):-
	longitud( N_aux, Cola),
	N is N_aux + 1.

/******************************************************************/
/******************************************************************/
/*1/3/2/2-master_mind/combinacion/sublista/binaria*/

/*** binaria( out, in) **************************/
/*** genera una lista booleana de longitud N ***/
binaria( [], 0):-!.
binaria([ Booleano| Cola_booleana], N):-
	N_aux is N - 1,
	binaria( Cola_booleana, N_aux),
	pertenece( Booleano, [ 1, 0]). %1/3/2/2/1

/******************************************************************/
/******************************************************************/
/*1/3/2/3-master_mind/combinacion/sublista/escoger_binaria*/
/* Este predicado selecciona una cifra booleana
 cuya suma sea la especificada en la variable "Suma" */

escoger_binaria( [], 0).
escoger_binaria( [ Digito| Cola_digitos], Suma):-
	escoger_binaria( Cola_digitos, Suma_aux),
	Suma is Suma_aux + Digito.

/******************************************************************/
/******************************************************************/
/*1/3/2/4-master_mind/combinacion/sublista/generar_cifra*/

/* Es un predicado auxiliar del predicado "lugar", que engendra en si mismo
una cifra especfica, segn un modelo binario preestablecido.
Se deriva de los predicados "lugar" y "sublista"*/

generar_cifra( [], [], []):-!.
generar_cifra( [ Cabeza_cifra| Cola_cifra],
	 [ Cabeza_binaria| Cola_binaria],
	 [ Cabeza_combinacion| Cola_combinacion]):-
	generar_cifra( Cola_cifra, Cola_binaria, Cola_combinacion),
	digito( Cabeza_cifra, Cabeza_binaria, Cabeza_combinacion). %1/3/2/4/1

/******************************************************************/
/******************************************************************/
/*1/3/2/5-master_mind/combinacion/sublista/sin_fantasma*/
sin_fantasma( [], []).
sin_fantasma( Cola_fantasma_aux, [ Cabeza_fantasma| Cola_fantasma]):-
		var( Cabeza_fantasma),
		sin_fantasma( Cola_fantasma_aux, Cola_fantasma),!.
sin_fantasma( [ Cabeza_fantasma| Cola_fantasma_aux],
	      [ Cabeza_fantasma| Cola_fantasma]):-
		sin_fantasma( Cola_fantasma_aux, Cola_fantasma).


/******************************************************************/
/******************************************************************/
/*1/3/3/1-master_mind/combinacion/permutacion/eliminar*/
eliminar( Cola, Elemento, [ Elemento| Cola]).
eliminar( [ Cabeza| Cola_sin], Elemento, [ Cabeza| Cola_con]):-
		eliminar( Cola_sin, Elemento, Cola_con).

/******************************************************************/
/******************************************************************/
/*1/4/1/1-master_mind/seleccion/ciclo_condiciones/posibilidad*/

/* Este predicado verifica si una combinacin especfica, alojada en
 la variable "Cifra" cumple con los requisitos de la jugada previa
 cuyo nmero se determina por la variable "Jugada". Dicha comprobacin
 la realiza generando, una por una, todas las posibilades derivadas de
 tal jugada, e intentando asociarla a la "Cifra" que se le entrega.
 Tambin genera, a discrecin todas las posibles cifras de cuatro
dgitos horizontales y */
/******************************************************************/
/* Descripcin de par metros:                                     */
/*				posibilidad(  In, In)	          */
/*				posibilidad(  Out, In)		  */
/******************************************************************/

posibilidad( Cifra, Jugada):-
		intento( Jugada, calificar( Posiciones, Digitos), Combinacion),
		lugar( Cifra, Posiciones, Combinacion), %1/4/1/1/1
		digitos_posibles( Lista_digitos, Cifra, Digitos, Combinacion), %1/4/1/1/2
		interpolacion( Lista_digitos, Cifra), %1/4/1/1/3
		interpolacion_condicionada( Cifra, Combinacion), %1/4/1/1/4
		no_redundante( Cifra, Lista_digitos, Combinacion). %1/4/1/1/5





/*ruta de cinco niveles*/
/******************************************************************/
/******************************************************************/
/******************************************************************/
/******************************************************************/

/******************************************************************/
/******************************************************************/
/*1/3/1/2/1-master_mind/combinacion/matriz/seleccionar_matriz_azar/factorial*/

/* La sintaxis es factorial(N, F) -> Factorial de N es F (el resultado se
guarda en F) el factorial se llama recursivamente dejando el resultado en F */
factorial( 1, 1) :- !.
factorial( N, Factorial) :-
	N_auxiliar is N - 1,
	factorial( N_auxiliar, Factorial_auxiliar),
	Factorial is N * Factorial_auxiliar.

/******************************************************************/
/******************************************************************/
/*1/3/1/3/1-master_mind/combinacion/matriz/generar_permutacion/lista_fantasma*/
/**** genera una lista de N elementos no instanciados.
 Se deriva del predicado "generar_permutacin"   */
lista_fantasma( [], 0):-!.
lista_fantasma( [ _| Cola_fantasma], N):-
	N_aux is N - 1,
	lista_fantasma(  Cola_fantasma, N_aux).
/******************************************************************/
/******************************************************************/
/*1/3/1/3/2-master_mind/combinacion/matriz/generar_permutacion/instanciar_matriz*/
/*instanciar una lista con una permutacin eNsima*/
instanciar_matriz( _, _, 0, _):-
	!,
	true.
instanciar_matriz( Momento, [ Cabeza| Cola], N, Matriz_permutada):-
	calcular_posicion( Momento, N, Posicion, Segmento_divisor), %1/3/1/3/2/1
	instanciar_matriz_posicion( Posicion, Cabeza, N, Matriz_permutada), %1/3/1/3/2/2
	calcular_parametros( N, Momento, Posicion, Segmento_divisor, %1/3/1/3/2/3
		     N_auxiliar, Momento_auxiliar),
	instanciar_matriz( Momento_auxiliar, Cola, N_auxiliar, Matriz_permutada).

/******************************************************************/
/******************************************************************/
/*1/3/2/2/1-master_mind/combinacion/sublista/binaria/pertenece*/
pertenece( X, [ X| _]).
pertenece( X, [ _| Y]):-
	pertenece( X, Y).


/******************************************************************/
/******************************************************************/
/*1/3/2/4/1-master_mind/combinacion/sublista/generar_cifra/digito */
digito( _, 0, _).
digito( Cabeza_combinacion, 1, Cabeza_combinacion).


/******************************************************************/
/******************************************************************/
/*1/4/1/1/1-master_mind/seleccion/ciclo_condiciones/posibilidad/lugar*/
/* Este predicado genera todas las cifras, a partir de una combinacin
 determinada; que consta de tantos dgitos, como la variable "Posiciones"
lo indica, posicionados segn dicha combinacin y tomados de la misma.
El resto de los cuales permanece sin precisar o instanciar.
Es un derivado del predicado "Posibilidad" */

lugar( Cifra, Posiciones, Combinacion):-
		binaria( Lista_binaria, 4),
		escoger_binaria( Lista_binaria, Posiciones),
		generar_cifra( Cifra, Lista_binaria, Combinacion).

/******************************************************************/
/******************************************************************/
/*1/4/1/1/2-master_mind/seleccion/ciclo_condiciones/posibilidad/digitos_posibles */

/********** Genera los dgitos que est n en la combinacin solucin,
pero que no se encuentran en el lugar adecuado. Observando que no se
repitan desde la cifra de posiciones correctas, previamente generada*/

digitos_posibles( Posibles_aux, Cifra_posicion, Digitos, Combinacion):-
	lugar( Posibles, Digitos, Combinacion),
	sin_fantasma( Posibles_aux, Posibles),
	not( alguna_intercepcion( Posibles_aux, Cifra_posicion)). %1/4/1/1/2/1



/******************************************************************/
/******************************************************************/
/*1/4/1/1/3-master_mind/seleccion/ciclo_condiciones/posibilidad/interpolacion */
/* este predicado interpola una lista de nmeros dentro
de otra que tiene elementos no instanciados */

interpolacion( [], _).
interpolacion( [ Cabeza| Cola], Interpolando):-
	pertenece( Cabeza, Interpolando),
	interpolacion( Cola, Interpolando).


/******************************************************************/
/******************************************************************/
/*1/4/1/1/4-master_mind/seleccion/ciclo_condiciones/posibilidad/interpolacion_condicionada */
interpolacion_condicionada( Interpolando, Condicion):-
	pertenece( Elemento, Interpolando),
	var(Elemento),
	pertenece( Elemento, [5,4,3,2,1,0]),
	not(pertenece( Elemento, Condicion)),
	interpolacion_condicionada( Interpolando, Condicion).
interpolacion_condicionada( Interpolando, _):-
	lista_instanciada( Interpolando). %1/4/1/1/4/1

/******************************************************************/
/******************************************************************/
/*1/4/1/1/4-master_mind/seleccion/ciclo_condiciones/posibilidad/no_redundante*/
no_redundante( _, [], _).
no_redundante( Cifra, [ Cabeza| Cola], Combinacion):-
	ubicacion( N_combinacion, Cabeza, Combinacion), %1/4/1/1/4/1
	ubicacion( N_cifra, Cabeza, Cifra),
	not( N_combinacion = N_cifra),
	no_redundante( Cifra, Cola, Combinacion).




/*ruta de seis niveles*/
/******************************************************************/
/******************************************************************/
/******************************************************************/
/******************************************************************/



/******************************************************************/
/******************************************************************/
/*1/3/1/3/2/1-master_mind/combinacion/matriz/generar_permutacion/instanciar_matriz/
calcular_posicion*/
/* calcular posicion segn momento aleatoreo*/
calcular_posicion( Momento, N, Posicion, Segmento_divisor):-
	factorial( N, Factorial),
	Segmento_divisor is Factorial / N,
	Posicion_auxiliar is Momento // Segmento_divisor,
	Resto is Momento mod Segmento_divisor,
	corregir_posicion( Posicion_auxiliar, Resto, Posicion). %1/3/1/3/2/1/1

/******************************************************************/
/******************************************************************/
/*1/3/1/3/2/2-master_mind/combinacion/matriz/generar_permutacion/instanciar_matriz/
instanciar_matriz_posicion*/
/*instancia el eNsimo espacio vaco de una lista*/
instanciar_matriz_posicion( 1, Elemento, _, [ Cabeza| _]):-
	var( Cabeza),
	Cabeza = Elemento. % posteriormente se puede introducir un elemento cualquiera
instanciar_matriz_posicion( Posicion, Elemento, N, [ Cabeza| Cola]):-
	var( Cabeza),
	Posicion_auxiliar is Posicion - 1,
	instanciar_matriz_posicion( Posicion_auxiliar, Elemento, N, Cola).
instanciar_matriz_posicion( Posicion, Elemento, N, [ Cabeza| Cola]):-
	nonvar( Cabeza),
	instanciar_matriz_posicion( Posicion, Elemento, N, Cola).


/******************************************************************/
/******************************************************************/
/*1/3/1/3/2/3-master_mind/combinacion/matriz/generar_permutacion/instanciar_matriz/
calcular_parametros*/
/* calcular parmetros recurrentes */
calcular_parametros( N, Momento_anterior, Posicion, Segmento_divisor,
		     M, Momento_posterior):-
	M is N - 1,
	Momento_posterior is
	Momento_anterior - ( Posicion - 1) * Segmento_divisor.



/******************************************************************/
/******************************************************************/
/*1/4/1/1/2/1-master_mind/seleccion/ciclo_condiciones/posibilidad/digitos_posibles/alguna_intercepcion */
alguna_intercepcion( Digitos_posibles, Cifra_posicion):-
		sin_fantasma( Cifra_aux, Cifra_posicion),
		pertenece( Comun, Digitos_posibles),
		pertenece( Comun, Cifra_aux).


/******************************************************************/
/******************************************************************/
/*1/4/1/1/4/1-master_mind/seleccion/ciclo_condiciones/posibilidad/interpolacion_condicionada/lista_instanciada */
lista_instanciada( []).
lista_instanciada( [ Cabeza| Cola]):-
	nonvar(Cabeza),
	lista_instanciada(Cola).

/******************************************************************/
/******************************************************************/
/*1/4/1/1/4/1-master_mind/seleccion/ciclo_condiciones/posibilidad/no_redundante/ubicacion(*/
ubicacion( 1, Elemento, [ Elemento| _]):-!.
ubicacion( N, Elemento, [ _| Cola]):-
	nonvar( Elemento),
	ubicacion( N_aux, Elemento, Cola),
	N is N_aux + 1.

ubicacion( N, Elemento, [ _| Cola]):-
    nonvar(N),
	N_aux is N - 1,
	ubicacion( N_aux, Elemento, Cola).


/*ruta de siete niveles*/
/******************************************************************/
/******************************************************************/
/******************************************************************/
/******************************************************************/



/******************************************************************/
/******************************************************************/
/*1/3/1/3/2/1/1-master_mind/combinacion/matriz/generar_permutacion/instanciar_matriz/
calcular_posicion/corregir_posicion*/
/* corrige posicion segun resto*/
corregir_posicion( Posicion, 0, Posicion):-
	!,
	true.
corregir_posicion( Posicion_auxiliar, _, Posicion):-
	Posicion is Posicion_auxiliar + 1.

